/* ---------------------------------------------------------------------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.  

   Copyright (c) 2001-2002 by Michal Ociepka <M.Ociepka@netsync.pl>

   For more info:
   http://xdefactor.netsync.pl
   --------------------------------------------------------------------- */

#include "callbacks.h"



void xdfDisconnect (xdfConnModule *conn_mod)
{
  conn_mod->kind_of_conn = 0;
  xdfConnSQL (conn_mod);
}
int main( int argc,
          char *argv[] )
{
  GtkWidget *window;
  GtkWidget *main_vbox;
  GtkWidget *menu[4];
  GtkWidget *root_menu[4];
  GtkWidget *menubar;
  GtkWidget *menu_items;  
  FILE *fp[2];
  GtkWidget *fixed_main; 
  char line[128];
	void *handle; 
  GString *string;
  int i;

  void (*xdef_module)(xdfConnModule *conn_mod);
  const char *err_msg;
  struct xdfDialogMsgStruct xdfDialogMsgStruct_;
  xdfConnModule conn_mod;
 
  xdfLogBehaviour (XDEF_START);  
  conn_mod.connect=-1;

  gtk_init (&argc, &argv);
  gtk_set_locale();

  conn_mod.kind_of_conn=1;

/* Nawiazywanie polaczenia z baza danych - PostgreSQL  */
  if(xdfConnSQL(&conn_mod) == 0){
    xdfDialogMsgStruct_.msg = g_string_new ("\nPolaczenie z baza danych zostalo nawiazane\n\n\tXdeFactor-ng");
    xdfDialogMsgStruct_.title = g_string_new ("RAPORT POLACZENIA Z BAZA DANYCH - XdeFactor-ng");
    xdfDialogMsgStruct_.type = GTK_MESSAGE_INFO;
  }else{
    xdfDialogMsgStruct_.msg = g_string_new ("\nPolaczenie z baza danych NIE zostalo nawiazane\n\n\tXdeFactor-ng");
    xdfDialogMsgStruct_.title = g_string_new ("RAPORT POLACZENIA Z BAZA DANYCH - XdeFactor-ng");
    xdfDialogMsgStruct_.type = GTK_MESSAGE_WARNING;
  }

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_resize (GTK_WINDOW (window),
		    800, 600);
  g_signal_connect (G_OBJECT (window), "destroy",
		    G_CALLBACK (xdfDisconnect),
		    &conn_mod);
  g_signal_connect (G_OBJECT (window), "destroy", 
		    G_CALLBACK (gtk_main_quit), 
		    NULL);

  gtk_window_set_title (GTK_WINDOW (window), TITLE);
  gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);

  fixed_main = gtk_fixed_new ();
  moduleAuthors (fixed_main);

  for(i=1; i != 5; i++){
    menu[i] = gtk_menu_new ();
  }
  root_menu[1] = gtk_menu_item_new_with_label (MENU_1);
  root_menu[2] = gtk_menu_item_new_with_label (MENU_2);
  root_menu[3] = gtk_menu_item_new_with_label (MENU_3);
  root_menu[4] = gtk_menu_item_new_with_label (MENU_4);

  for(i=1; i != 5; i++){
    gtk_widget_show (root_menu[i]);
  }

  string = g_string_new (HOME_DIR);

  if((fp[1] = fopen (MODULES, "r")) < 0){
    perror (MODULES);
    exit(EXIT_FAILURE);
  }

  while ((fgets (line, 127, fp[1])) != NULL){
    if(line[0] != '#'){
/* tu uzyskujemy plik opisujacy modul */
      line[ strlen(line)-1] = '\0'; 
/* wyznaczam kompletna sciezke opisujaca modul */
      g_string_append (string, line); 

/* szukaj miejsce w jakim menu wrzucic modul */
      search (string->str, "submenu", line);   
      menu_items = gtk_menu_item_new_with_label(line);
      search (string->str, "menu", line);   
/* sprawdzam gdzie umiescic modul */
      if(strcmp (line, MENU_1) == 0)
	gtk_menu_shell_append (GTK_MENU_SHELL (menu[1]), menu_items);
      if(strcmp (line, MENU_2) == 0)
	gtk_menu_shell_append (GTK_MENU_SHELL (menu[2]), menu_items);
      if(strcmp (line, MENU_3) == 0)
	gtk_menu_shell_append (GTK_MENU_SHELL (menu[3]), menu_items);
      if(strcmp (line, MENU_4) == 0)
	gtk_menu_shell_append (GTK_MENU_SHELL (menu[4]), menu_items);

      fgets (line, 127, fp[1]);
      line[ strlen(line)-1] = '\0'; /* nazwa modulu */
/* laduje odpowiedni obiekt */
      handle = dlopen (line, RTLD_LAZY); 
      if(handle == NULL) {
	printf("Nie moge zaladowac obiektu: %s\n. Blad: %s\n", line, dlerror());
	exit (EXIT_FAILURE);
      }
/* czyscimy lancuch bledu */
      dlerror ();
/* sprawdzam i ustalam jaka funkcje ma modul */
      search (string->str, "name", line);
      xdef_module = dlsym(handle, line);

      if ((err_msg = dlerror ()) != NULL) {
	printf("Nie moge odnalezc funkcji: %s\n", err_msg);
	exit (EXIT_FAILURE);
      }

/* Wywolujemy funkcje, ktora pokaze nam modul */
      g_signal_connect_swapped (G_OBJECT (menu_items), "activate",
				G_CALLBACK (xdef_module),
				&conn_mod);

/* wyrzucam sciezke dla modulu poprzedniego */
      g_string_erase (string, strlen(HOME_DIR), -1);
      gtk_widget_show (menu_items);
    }
  }
  for(i=1; i != 5; i++){
    gtk_menu_item_set_submenu (GTK_MENU_ITEM (root_menu[i]), menu[i]);
  }
	/* Konczymy aplikacje */
  menu_items = gtk_menu_item_new_with_label("Koniec");
	gtk_menu_shell_append (GTK_MENU_SHELL (menu[1]), menu_items);

  /* Wywolujemy funkcje, ktora pokaze nam modul */
  g_signal_connect_swapped (G_OBJECT (menu_items), "activate",
	G_CALLBACK (gtk_main_quit),
	NULL);

/* wyrzucam sciezke dla modulu poprzedniego */
  g_string_erase (string, strlen(HOME_DIR), -1);
  gtk_widget_show (menu_items);

  main_vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window), main_vbox);
  gtk_widget_show (main_vbox);
 
  menubar = gtk_menu_bar_new (); 
  gtk_box_pack_start (GTK_BOX (main_vbox), menubar, FALSE, TRUE, 1);
  gtk_widget_show (menubar);

  gtk_box_pack_start (GTK_BOX (main_vbox), fixed_main, FALSE, TRUE, 0);

  for(i=1; i != 5; i++){
    gtk_menu_shell_append (GTK_MENU_SHELL (menubar), root_menu[i]);
  }

  gtk_widget_show (fixed_main);
  gtk_widget_show (window);
  xdfDialogMsg (&xdfDialogMsgStruct_);

  gtk_main ();
  g_string_free (string, TRUE);

  return 0;
}
