#include "moduleClients.h"

PGconn *conn_find;
PGresult *res;
ExecStatusType est;
GtkWidget *entry_search_nip, *entry_name, *entry_nip, *entry_regon, *entry_street, *entry_postal_code, *entry_city, *entry_bank, *entry_nr_bank, *entry_tel, *entry_fax, *entry_email, *entry_www, *entry_discount, *entry_contact_person, *entry_search_no;

void updateFromClist (char *id)
{
  GtkWidget *widget;

  ENTRY_SET_TEXT (entry_search_no, id);
  findClient (widget, GINT_TO_POINTER (1));
}
void findClient(GtkWidget *widget, gpointer data)
{
  GString *value = g_string_new ("value");
  GString *sort	 = g_string_new ("sort");
  GString *query = g_string_new ("query");
  int i;
  struct xdfDialogMsgStruct msg_struct;

  i=0;

  if( GPOINTER_TO_INT (data) == 0){
    g_string_printf (value, "%s", ENTRY_GET_TEXT (entry_search_nip));
    g_string_printf (sort, "nip");
  }else if ( GPOINTER_TO_INT (data) == 1){
    g_string_printf (value, "%s", ENTRY_GET_TEXT (entry_search_no));
    g_string_printf (sort, "no");
  }

  PQexec (conn_find, "BEGIN;");
  g_string_printf (query, "SELECT no, nip, regon, name, street, postal_code, city, contact_person, telephone, fax, email, www, bank, nr_bank, discount FROM clients WHERE %s='%s' and is_active='TRUE';", sort->str, value->str);

  res = PQexec (conn_find, query->str);
  msg_struct.title = g_string_new ("Raport poszukiwan nabywcy -- XdeFactor");

  if (PQntuples(res) == 0){
    msg_struct.type = GTK_MESSAGE_ERROR;
    msg_struct.msg = g_string_new ("NIE MA TAKIEGO NABYWCY / ODBIORCY \n\n\t XdeFactor-ng");
    xdfDialogMsg (&msg_struct);
    goto END;
  }
  for (i=0; i < PQntuples(res); i++){
    ENTRY_SET_TEXT (entry_search_no, PQgetvalue (res, i, 0));
    ENTRY_SET_TEXT (entry_search_nip, PQgetvalue (res, i, 1));
    ENTRY_SET_TEXT (entry_nip, PQgetvalue (res, i, 1));
    ENTRY_SET_TEXT (entry_regon,PQgetvalue (res, i, 2));
    ENTRY_SET_TEXT (entry_name, PQgetvalue (res, i, 3));
    ENTRY_SET_TEXT (entry_street, PQgetvalue (res, i, 4));
    ENTRY_SET_TEXT (entry_postal_code, PQgetvalue (res, i, 5));
    ENTRY_SET_TEXT (entry_city, PQgetvalue (res, i, 6));
    ENTRY_SET_TEXT (entry_contact_person, PQgetvalue (res, i, 7));
    ENTRY_SET_TEXT (entry_tel, PQgetvalue (res, i, 8));
    ENTRY_SET_TEXT (entry_fax, PQgetvalue (res, i, 9));
    ENTRY_SET_TEXT (entry_email, PQgetvalue (res, i, 10));
    ENTRY_SET_TEXT (entry_www, PQgetvalue (res, i, 11));
    ENTRY_SET_TEXT (entry_bank, PQgetvalue (res, i, 12));
    ENTRY_SET_TEXT (entry_nr_bank, PQgetvalue (res, i, 13));
    ENTRY_SET_TEXT (entry_discount, PQgetvalue (res, i, 14));
  }

       
  END:
 
  PQexec (conn_find, "COMMIT;");

  g_string_free (value, TRUE);
  g_string_free (query, TRUE);  
  g_string_free (sort , TRUE);  
}
void clean (GtkWidget *widget)
{
  ENTRY_SET_TEXT (entry_search_no,"");
  ENTRY_SET_TEXT (entry_search_nip,"");
  ENTRY_SET_TEXT (entry_nip, "");
  ENTRY_SET_TEXT (entry_regon,"");
  ENTRY_SET_TEXT (entry_name,"");
  ENTRY_SET_TEXT (entry_street,"");
  ENTRY_SET_TEXT (entry_postal_code,"");
  ENTRY_SET_TEXT (entry_city,"");
  ENTRY_SET_TEXT (entry_contact_person,"");
  ENTRY_SET_TEXT (entry_tel,"");
  ENTRY_SET_TEXT (entry_fax,"");
  ENTRY_SET_TEXT (entry_email,"");
  ENTRY_SET_TEXT (entry_www, "");
  ENTRY_SET_TEXT (entry_bank, "");
  ENTRY_SET_TEXT (entry_nr_bank,"");
  ENTRY_SET_TEXT (entry_discount, "");
}
void addClient (GtkWidget *widget, xdfConnModule *conn_mod)
{
  GString *string_no	  = g_string_new ("start");
  GString *string_query	  = g_string_new ("start");
  struct xdfDialogMsgStruct msg_struct;

  msg_struct.title = g_string_new ("Raport opercji na kliencie");
  PQexec (conn_mod->conn, "BEGIN;");

  res = PQexec (conn_mod->conn, "SELECT MAX(no) FROM clients;");
  if (PQgetisnull (res, 0, 0))
    g_string_printf (string_no, "%d", 1);
  else
    g_string_printf (string_no, "(SELECT MAX(no)+1 FROM clients)");

  if (modifyClient (string_no, conn_mod) == 0){
    msg_struct.msg = g_string_new ("Wlasnie dodalem nabywce / odbiorce \n\n\t XdeFactor-ng");
    msg_struct.type=GTK_MESSAGE_INFO;
  }else{
    msg_struct.msg = g_string_new ("DODANIE NOWEGO NABYWCY/ODBIORCY ZAKONCZYLO SIE NIEPOWODZENIEM!! \n\n SPRAWDZ CZY DOBRZE WYPELNILES FORMULARZ !! \n\n\t XdeFactor-ng");
    msg_struct.type=GTK_MESSAGE_WARNING;
  }

  PQexec (conn_mod->conn, "COMMIT;");
  xdfDialogMsg (&msg_struct);
  g_string_free (string_no, TRUE);
  g_string_free (string_query, TRUE);
}
void updateClient (GtkWidget *widget, xdfConnModule *conn_mod)
{
  GString *string_no	  = g_string_new ("start");
  GString *string_query	  = g_string_new ("start");
  struct xdfDialogMsgStruct msg_struct;

  msg_struct.title = g_string_new ("Raport opercji na kliencie");
  PQexec (conn_mod->conn, "BEGIN;");

  g_string_printf (string_query, "UPDATE clients SET is_active='FALSE' WHERE no='%s';", ENTRY_GET_TEXT (entry_search_no));
  PQexec (conn_mod->conn, string_query->str);
  g_string_printf (string_no, "%s", ENTRY_GET_TEXT (entry_search_no));

  if (modifyClient (string_no, conn_mod) == 0){
    msg_struct.msg = g_string_new ("Wlasnie uaktualnilem nabywce / odbiorce \n\n\t XdeFactor-ng");
    msg_struct.type=GTK_MESSAGE_INFO;
  }else{
    msg_struct.msg = g_string_new ("UAKTUALNIENIE NABYWCY/ODBIORCY ZAKONCZYLO SIE NIEPOWODZENIEM!! \n\n SPRAWDZ CZY DOBRZE WYPELNILES FORMULARZ !! \n\n\t XdeFactor-ng");
    msg_struct.type=GTK_MESSAGE_WARNING;
  }

  PQexec (conn_mod->conn, "COMMIT;");
  xdfDialogMsg (&msg_struct);
  g_string_free (string_no, TRUE);
  g_string_free (string_query, TRUE);
}
void removeClient (GtkWidget *widget, xdfConnModule *conn_mod)
{
  GString *string_query	  = g_string_new ("start");
  struct xdfDialogMsgStruct msg_struct;

  msg_struct.title = g_string_new ("Raport opercji na kliencie");

  g_string_printf (string_query, "UPDATE clients SET is_active='FALSE' WHERE no='%s';", ENTRY_GET_TEXT (entry_search_no));
  PQexec (conn_mod->conn, string_query->str);
  msg_struct.msg = g_string_new ("Wlasnie usunalem nabywce / odbiorce \n\n\t XdeFactor-ng");
  msg_struct.type=GTK_MESSAGE_INFO;
  xdfDialogMsg (&msg_struct);

  g_string_free (string_query, TRUE);
}
int modifyClient (GString *string_no, xdfConnModule *conn_mod)
{
  GString *string_query = g_string_new ("query");

  g_string_printf (string_query, "INSERT INTO clients(                                                            no,nip,regon,name,street,postal_code,city,contact_person,telephone,fax,email,www,bank,nr_bank,discount,creator_id) VALUES ( %s,'%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s',(SELECT id FROM users WHERE interface='xdefactor-ng' and ip='%s' and is_logged_in='TRUE'));", string_no->str, ENTRY_GET_TEXT(entry_nip), ENTRY_GET_TEXT(entry_regon), ENTRY_GET_TEXT(entry_name), ENTRY_GET_TEXT(entry_street), ENTRY_GET_TEXT(entry_postal_code), ENTRY_GET_TEXT(entry_city), ENTRY_GET_TEXT(entry_contact_person), ENTRY_GET_TEXT(entry_tel), ENTRY_GET_TEXT(entry_fax), ENTRY_GET_TEXT(entry_email), ENTRY_GET_TEXT(entry_www), ENTRY_GET_TEXT(entry_bank), ENTRY_GET_TEXT(entry_nr_bank), ENTRY_GET_TEXT(entry_discount), conn_mod->ip->str); 

  res = PQexec (conn_mod->conn, string_query->str);
  est = PQresultStatus (res);

  g_print ("%s+++\n", PQresStatus (est));
  if (strcmp (PQresStatus (est), "PGRES_COMMAND_OK") == 0){
    g_string_free (string_query, TRUE);
    g_string_free (string_no, TRUE);
    return 0;
  }else{
    g_string_free (string_query, TRUE);
    g_string_free (string_no, TRUE);
    g_print ("FAILED");
    return -1;
  }
}

void moduleClients(xdfConnModule *conn_mod)
{
  GtkWidget *window_clients;
  GtkWidget *fixed27;
  GtkWidget *frame_search;
  GtkWidget *fixed_search;
  GtkWidget *button_search_nip;
  GtkWidget *button_search_no;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *frame_clients;
  GtkWidget *fixed_clients;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *label5;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *label8;
  GtkWidget *label9;
  GtkWidget *label11;
  GtkWidget *label10;
  GtkWidget *label_per;
  GtkWidget *hseparator1;
  GtkWidget *label12;
  GtkWidget *hseparator2;
  GtkWidget *hseparator3;
  GtkWidget *hseparator4;
  GtkWidget *button_remove;
  GtkWidget *label13;
  GtkWidget *label14;
  GtkWidget *button_add;
  GtkWidget *button_update;
  GtkWidget *button_clean;
  GtkWidget *button_show_clist;
  GtkWidget *label15;
  GtkWidget *label16;
  struct xdfDialogMsgStruct msg_struct;

  if (conn_mod->connect == 0){

  conn_find = conn_mod->conn;

  window_clients = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window_clients), "Odbiorcy  -- XdeFactor-ng ");
  gtk_window_set_position (GTK_WINDOW (window_clients), GTK_WIN_POS_CENTER);
  gtk_window_resize (GTK_WINDOW (window_clients), 600, 500);
  gtk_widget_show (GTK_WIDGET (window_clients));

  fixed27 = gtk_fixed_new ();
  gtk_widget_show (fixed27);
  gtk_container_add (GTK_CONTAINER (window_clients), fixed27);

  frame_search = gtk_frame_new ("Znajdz odbiorce");
  gtk_widget_show (frame_search);
  gtk_fixed_put (GTK_FIXED (fixed27), frame_search, 8, 8);
  gtk_widget_set_usize (frame_search, 584, 66);

  fixed_search = gtk_fixed_new ();
  gtk_widget_show (fixed_search);
  gtk_container_add (GTK_CONTAINER (frame_search), fixed_search);

  entry_search_nip = gtk_entry_new ();
  gtk_widget_show (entry_search_nip);
  gtk_fixed_put (GTK_FIXED (fixed_search), entry_search_nip, 88, 8);
  gtk_widget_set_usize (entry_search_nip, 110, 22);

  button_search_nip = gtk_button_new_from_stock (GTK_STOCK_FIND);
  gtk_widget_show (button_search_nip);
  gtk_fixed_put (GTK_FIXED (fixed_search), button_search_nip, 208, 8);
  gtk_widget_set_usize (button_search_nip, 96, 24);

  entry_search_no = gtk_entry_new ();
  gtk_fixed_put (GTK_FIXED (fixed_search), entry_search_no, 400, 8);
  gtk_widget_set_usize (entry_search_no, 48, 24);
  gtk_widget_show (entry_search_no);

  button_search_no = gtk_button_new_from_stock (GTK_STOCK_FIND);
  gtk_widget_show (button_search_no);
  gtk_fixed_put (GTK_FIXED (fixed_search), button_search_no, 456, 8);
  gtk_widget_set_usize (button_search_no, 96, 24);

  label2 = gtk_label_new ("Numer ID :");
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (fixed_search), label2, 328, 8);
  gtk_widget_set_usize (label2, 72, 24);

  frame_clients = gtk_frame_new ("Informacje o odbiorcach");
  gtk_widget_show (frame_clients);
  gtk_fixed_put (GTK_FIXED (fixed27), frame_clients, 8, 80);
  gtk_widget_set_usize (frame_clients, 586, 475);

  fixed_clients = gtk_fixed_new ();
  gtk_widget_show (fixed_clients);
  gtk_container_add (GTK_CONTAINER (frame_clients), fixed_clients);

  entry_name = gtk_entry_new ();
  gtk_widget_show (entry_name);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_name, 272, 8);
  gtk_widget_set_usize (entry_name, 280, 21);

  entry_nip = gtk_entry_new ();
  gtk_widget_show (entry_nip);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_nip, 272, 32);
  gtk_widget_set_usize (entry_nip, 112, 20);
  gtk_entry_set_max_length (GTK_ENTRY (entry_nip), 16);

  entry_regon = gtk_entry_new ();
  gtk_widget_show (entry_regon);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_regon, 272, 56);
  gtk_widget_set_usize (entry_regon, 112, 20);
  gtk_entry_set_max_length (GTK_ENTRY (entry_regon), 9);

  label3 = gtk_label_new ("Nazwa firmy / Nazwisko i imie :");
  gtk_widget_show (label3);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label3, 54, 8);
  gtk_widget_set_usize (label3, 200, 24);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label3), TRUE);

  label4 = gtk_label_new ("Numer NIP :");
  gtk_widget_show (label4);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label4, 54, 32);
  gtk_widget_set_usize (label4, 200, 24);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label4), TRUE);

  label5 = gtk_label_new ("Numer REGON :");
  gtk_widget_show (label5);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label5, 54, 56);
  gtk_widget_set_usize (label5, 200, 24);
  gtk_label_set_justify (GTK_LABEL (label5), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label5), TRUE);

  entry_street = gtk_entry_new ();
  gtk_widget_show (entry_street);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_street, 272, 80);
  gtk_widget_set_usize (entry_street, 280, 20);

  entry_postal_code = gtk_entry_new ();
  gtk_widget_show (entry_postal_code);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_postal_code, 272, 104);
  gtk_widget_set_usize (entry_postal_code, 112, 22);
  gtk_entry_set_max_length (GTK_ENTRY (entry_postal_code), 6);

  entry_city = gtk_entry_new ();
  gtk_widget_show (entry_city);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_city, 272, 128);
  gtk_widget_set_usize (entry_city, 280, 22);

  label6 = gtk_label_new ("Adres :");
  gtk_widget_show (label6);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label6, 54, 80);
  gtk_widget_set_usize (label6, 200, 24);
  gtk_label_set_justify (GTK_LABEL (label6), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label6), TRUE);

  entry_bank = gtk_entry_new ();
  gtk_widget_show (entry_bank);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_bank, 272, 152);
  gtk_widget_set_usize (entry_bank, 280, 22);

  entry_nr_bank = gtk_entry_new ();
  gtk_widget_show (entry_nr_bank);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_nr_bank, 272, 176);
  gtk_widget_set_usize (entry_nr_bank, 280, 22);

  label7 = gtk_label_new ("Kod pocztowy :");
  gtk_widget_show (label7);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label7, 54, 104);
  gtk_widget_set_usize (label7, 200, 24);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label7), TRUE);

  label8 = gtk_label_new ("Miejscowosc :");
  gtk_widget_show (label8);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label8, 54, 128);
  gtk_widget_set_usize (label8, 200, 24);
  gtk_label_set_justify (GTK_LABEL (label8), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label8), TRUE);

  label9 = gtk_label_new ("Nazwa banku :");
  gtk_widget_show (label9);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label9, 54, 152);
  gtk_widget_set_usize (label9, 200, 24);
  gtk_label_set_justify (GTK_LABEL (label9), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label9), TRUE);

  entry_tel = gtk_entry_new ();
  gtk_widget_show (entry_tel);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_tel, 272, 224);
  gtk_widget_set_usize (entry_tel, 114, 22);

  label11 = gtk_label_new ("Telefon :");
  gtk_widget_show (label11);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label11, 54, 224);
  gtk_widget_set_usize (label11, 80, 24);
  gtk_label_set_justify (GTK_LABEL (label11), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label11), TRUE);

  label10 = gtk_label_new ("Numer konta :");
  gtk_widget_show (label10);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label10, 54, 176);
  gtk_widget_set_usize (label10, 200, 24);
  gtk_label_set_justify (GTK_LABEL (label10), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label10), TRUE);

  entry_fax = gtk_entry_new ();
  gtk_widget_show (entry_fax);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_fax, 272, 248);
  gtk_widget_set_usize (entry_fax, 114, 22);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_fixed_put (GTK_FIXED (fixed_clients), hseparator1, 8, 208);
  gtk_widget_set_usize (hseparator1, 565, 16);

  label12 = gtk_label_new ("Faks :");
  gtk_widget_show (label12);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label12, 54, 248);
  gtk_widget_set_usize (label12, 53, 24);
  gtk_label_set_justify (GTK_LABEL (label12), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label12), TRUE);

  entry_email = gtk_entry_new ();
  gtk_widget_show (entry_email);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_email, 137, 298);
  gtk_widget_set_usize (entry_email, 135, 22);

  entry_www = gtk_entry_new ();
  gtk_widget_show (entry_www);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_www, 392, 298);
  gtk_widget_set_usize (entry_www, 158, 22);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (hseparator2);
  gtk_fixed_put (GTK_FIXED (fixed_clients), hseparator2, 8, 272);
  gtk_widget_set_usize (hseparator2, 565, 16);

  entry_contact_person = gtk_entry_new ();
  gtk_widget_show (entry_contact_person);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_contact_person, 208, 338);
  gtk_widget_set_usize (entry_contact_person, 184, 22);

  hseparator3 = gtk_hseparator_new ();
  gtk_widget_show (hseparator3);
  gtk_fixed_put (GTK_FIXED (fixed_clients), hseparator3, 8, 322);
  gtk_widget_set_usize (hseparator3, 565, 16);

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_show (hseparator4);
  gtk_fixed_put (GTK_FIXED (fixed_clients), hseparator4, 10, 355);
  gtk_widget_set_usize (hseparator4, 565, 16);

  button_remove = gtk_button_new_from_stock (GTK_STOCK_DELETE);
  gtk_widget_show (button_remove);
  gtk_fixed_put (GTK_FIXED (fixed_clients), button_remove, 8, 373);
  gtk_widget_set_usize (button_remove, 104, 24);

  button_show_clist = gtk_button_new_from_stock (GTK_STOCK_INDEX);
  gtk_widget_show (button_show_clist);
  gtk_fixed_put (GTK_FIXED (fixed_clients), button_show_clist, 8, 405);
  gtk_widget_set_usize (button_show_clist, 104, 24);

  label13 = gtk_label_new ("Email :");
  gtk_widget_show (label13);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label13, 54, 298);
  gtk_widget_set_usize (label13, 48, 24);
  gtk_label_set_justify (GTK_LABEL (label13), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label13), TRUE);

  label14 = gtk_label_new ("Strona www :");
  gtk_widget_show (label14);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label14, 296, 298);
  gtk_widget_set_usize (label14, 150, 24);
  gtk_label_set_justify (GTK_LABEL (label14), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label14), TRUE);

  button_update = gtk_button_new ();
  gtk_button_set_label (GTK_BUTTON (button_update), "Uaktualnij");
  gtk_widget_show (button_update);
  gtk_fixed_put (GTK_FIXED (fixed_clients), button_update, 440, 405);
  gtk_widget_set_usize (button_update, 112, 24);


  button_add = gtk_button_new_from_stock (GTK_STOCK_ADD);
  gtk_widget_show (button_add);
  gtk_fixed_put (GTK_FIXED (fixed_clients), button_add, 440, 373);
  gtk_widget_set_usize (button_add, 112, 24);


  button_clean = gtk_button_new_from_stock(GTK_STOCK_CLEAR);
  gtk_widget_show (button_clean);
  gtk_fixed_put (GTK_FIXED (fixed_clients), button_clean, 440, 437);
  gtk_widget_set_usize (button_clean, 112, 24);

  label15 = gtk_label_new ("Przedstawiciel firmy :");
  gtk_widget_show (label15);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label15, 54, 336);
  gtk_widget_set_usize (label15, 158, 24);
  gtk_label_set_justify (GTK_LABEL (label15), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label15), TRUE);

  label16 = gtk_label_new ("Rabat :");
  gtk_widget_show (label16);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label16, 400, 338);
  gtk_widget_set_usize (label16, 48, 24);
  gtk_label_set_justify (GTK_LABEL (label16), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label16), TRUE);

  entry_discount = gtk_entry_new ();
  gtk_widget_show (entry_discount);
  gtk_fixed_put (GTK_FIXED (fixed_clients), entry_discount, 464, 338);
  gtk_widget_set_usize (entry_discount, 57, 22);
  ENTRY_SET_TEXT (entry_discount, "0");

  label_per = gtk_label_new ("%");
  gtk_widget_show (label_per);
  gtk_fixed_put (GTK_FIXED (fixed_clients), label_per, 530, 343);

  label1 = gtk_label_new ("Numer NIP :");
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed_search), label1, 0, 8);
  gtk_widget_set_usize (label1, 88, 24);

  gtk_signal_connect (GTK_OBJECT (button_show_clist), "clicked", GTK_SIGNAL_FUNC (showClientsClist), conn_mod);
  gtk_signal_connect (GTK_OBJECT (button_update), "clicked", GTK_SIGNAL_FUNC (updateClient), conn_mod);
  gtk_signal_connect (GTK_OBJECT (button_add), "clicked", GTK_SIGNAL_FUNC (addClient), conn_mod);
  gtk_signal_connect (GTK_OBJECT (button_remove), "clicked", GTK_SIGNAL_FUNC (removeClient), conn_mod);
  gtk_signal_connect (GTK_OBJECT (button_search_nip), "clicked", GTK_SIGNAL_FUNC (findClient), GINT_TO_POINTER (0));
  gtk_signal_connect (GTK_OBJECT (button_search_no), "clicked", GTK_SIGNAL_FUNC (findClient), GINT_TO_POINTER (1));
  gtk_signal_connect (GTK_OBJECT (button_clean), "clicked", GTK_SIGNAL_FUNC (clean), NULL);
  }else{
    msg_struct.msg = g_string_new ("Najpierw musisz sie zalogowac !! \n\n\t XdeFactor-ng");
    msg_struct.type=GTK_MESSAGE_WARNING;
    xdfDialogMsg (&msg_struct);
    g_string_free (msg_struct.msg, TRUE);
  }

}

GtkWidget *xdfDialogMsg (struct xdfDialogMsgStruct *strDialog)
{
  GtkWidget *dialog;
  GtkWidget *window;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   
  dialog = gtk_message_dialog_new (GTK_WINDOW (window),
				   GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				   strDialog->type,
				   GTK_BUTTONS_OK,
				   strDialog->msg->str);
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
  gtk_widget_show (dialog);

  gtk_dialog_run (GTK_DIALOG (dialog));
  gtk_widget_destroy (dialog);

  return dialog;  
}
