#include <gtk/gtk.h>
#include <postgresql/libpq-fe.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>


#ifndef __MODULE_LOGIN_H__
#define __MODULE_LOGIN_H__

#define ENTRY_GET_TEXT(entry) gtk_entry_get_text(GTK_ENTRY(entry))
#define ENTRY_SET_TEXT(a,b) gtk_entry_set_text(GTK_ENTRY(a), b)
#define OBJ_GET_DATA(a, b)    gtk_object_get_data (GTK_OBJECT(a), b);

struct xdfDialogMsgStruct
{
  GString *title;
  GString *msg;
  GtkMessageType type;
};
typedef struct 
{
  PGconn *conn;
  int connect;
  int userID;
  GString *ip;
} xdfConnModule;

void moduleClients (xdfConnModule *conn_mod);

/**
  Funkcja ta sluzy zarowno do dodawania, jak i uaktualniania nabywcy.
  @param widget - Widget, ktory wywola funkcje, u nas jest to "button".
  @param kind_of_function - jesli ten parametr przyjmuje wartosc 0, wtedy dodawany jest nowy klient (odbiorca), jesli 1 - uaktualniany, jesli -1 usuwany.
  @author Michal Ociepka <M.Ociepka@netsync.pl>
*/
void Client (GtkWidget *widget, gpointer data);

void findClient (GtkWidget *widget, gpointer data);

void clean (GtkWidget *widget);

void addClient (GtkWidget *widget, xdfConnModule *conn_mod);

void updateClient (GtkWidget *widget, xdfConnModule *conn_mod);

void removeClient (GtkWidget *widget, xdfConnModule *conn_mod);

int modifyClient (GString *string_no, xdfConnModule *conn_mod);

void updateFromClist (char *id);

GtkWidget *xdfDialogMsg (struct xdfDialogMsgStruct *strDialog);

void showClientsClist (GtkWidget *widget, xdfConnModule *conn_mod);


#endif /* __MODULE_LOGIN_H__ */
