#include "moduleGoods.h"

void findGoods (GtkWidget *widget, xdfConnModule *conn_mod)
{
  GString *query = g_string_new ("query");
  GString *search_by;
  PGresult *res;
  int i;
  struct xdfDialogMsgStruct msg_struct;
  extern GtkWidget *entry_name, 
		   *entry_bought, 
		   *entry_sww, 
		   *entry_kod, 
		   *entry_sell, 
		   *entry_mag, 
		   *entry_state, 
		   *combo_entry1, 
		   *combo_entry2, 
		   *checkbutton1,
		   *combo_entry3, 
		   *entry_search;

  i=0;

  if (strcmp ("Numer ID", ENTRY_GET_TEXT (combo_entry1)) == 0)
    search_by = g_string_new ("goods_data.no");
  else if (strcmp ("Kod", ENTRY_GET_TEXT (combo_entry1)) == 0)
    search_by = g_string_new ("goods.code"); 
  else if (strcmp ("Nazwa", ENTRY_GET_TEXT (combo_entry1)) == 0)
    search_by = g_string_new ("goods.name");

/* 
 * W combo_entry1 trzymamy rozaj wyszukiwan
 * W entry_search mamy wartosc
 */

  g_string_printf (query, "SELECT 
			  goods.name, 
			  goods.sww,
			  goods.code, 
			  kinds_of_goods.name, 
			  units.memo, 
			  goods_data.bought_price, 
			  goods_data.tax_vat,
			  states_of_goods.name, 
			  goods_data.sell_price, 
			  stores_id, 
			  goods_data.store_state, 
			  goods_data.no 
			  FROM 
			  goods, 
			  states_of_goods,
			  goods_data, 
			  units, 
			  kinds_of_goods 
			  WHERE 
			  %s ILIKE '%%%s%%' 
			  and units.id=goods.units_id 
			  and goods.kinds_of_goods_id=kinds_of_goods.id 
			  and goods.id=goods_data.goods_id 
			  and goods.states_of_goods_id=states_of_goods.id
			  and goods.is_active='TRUE';", 
			  search_by->str, ENTRY_GET_TEXT (entry_search));

  res = PQexec (conn_mod->conn, query->str);
  msg_struct.title = g_string_new ("Raport poszukiwan towaru / uslugi -- XdeFactor");

  if (PQntuples(res) == 0){
    msg_struct.type = GTK_MESSAGE_ERROR;
    msg_struct.msg = g_string_new ("NIE MA TAKIEGO TOWARU / USLUGI \n\n\t XdeFactor-ng");
    xdfDialogMsg (&msg_struct);
    goto END;
  }
  gtk_entry_set_text (GTK_ENTRY (combo_entry1), "Numer ID");
  for (i=0; i < PQntuples(res); i++){
    ENTRY_SET_TEXT (entry_name , PQgetvalue (res, i, 0));
    ENTRY_SET_TEXT (entry_sww, PQgetvalue (res, i, 1));
    ENTRY_SET_TEXT (entry_kod,PQgetvalue (res, i, 2));

    if (strcmp ("towar", PQgetvalue (res, i, 3)) == 0)
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton1), FALSE);
    else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton1), TRUE);

    ENTRY_SET_TEXT (combo_entry2, PQgetvalue (res, i, 4));

    ENTRY_SET_TEXT (entry_bought, PQgetvalue (res, i, 5));

    if (strcmp ("bez podatku", PQgetvalue (res, i, 7)) == 0)
      ENTRY_SET_TEXT (combo_entry3, "zw");
    else
      ENTRY_SET_TEXT (combo_entry3, PQgetvalue (res, i, 6));
 
    ENTRY_SET_TEXT (entry_sell, PQgetvalue (res, i, 8));
    ENTRY_SET_TEXT (entry_mag, PQgetvalue (res, i, 9));
    ENTRY_SET_TEXT (entry_state, PQgetvalue (res, i, 10));
    ENTRY_SET_TEXT (entry_search, PQgetvalue (res, i, 11));
  }

       
  END:
 
  g_string_free (query, TRUE);  
  g_string_free (search_by , TRUE);  
  g_string_free (msg_struct.title, TRUE);
}
