#include <gtk/gtk.h>
#include <postgresql/libpq-fe.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "xdef.h"
#include "xdfDialogMsg.h"

#ifndef __MODULE_GOODS_H__
#define __MODULE_GOODS_H__

#define ENTRY_GET_TEXT(a) gtk_entry_get_text(GTK_ENTRY(a))
#define ENTRY_SET_TEXT(a,b) gtk_entry_set_text(GTK_ENTRY(a),b)

enum {
  XDF_VERIFY_GOODS_ON	      =  1,
  XDF_VERIFY_GOODS_OFF	      =  0,
  XDF_STORE_ADD		      =	 1,
  XDF_STORE_REM		      = -1,
  XDF_VERIFY_OK		      =	 0,
  XDF_VERIFY_UNSUCCESSFUL     =	-2,
  XDF_ADD_GOODS_UNSUCCESSFUL  =	-1,
  XDF_SUCCESSFUL	      =  0,
  XDF_UNSUCCESSFUL	      = -1,
  XDF_ELSE		      = -2
}; 

void moduleGoods (xdfConnModule *conn_mod);

/**
  @param  *string_no Numer goods_data.no 
  @param  *conn_mod Wskaznik do struktury xdfConnModule opisujacej polaczenie z baza danych
  @param  int code_verify Liczba okreslajaca weryfikacje kodu towaru/uslugi. Dla wartosci '0' weryfikacja jest wylaczona, dla '1' wlaczona 
  @return '-2' dla zlej weryfikacji kodu, '-1' dla nieudanego fofania towaru, '0' gdy wszystko jest dobrze.
  @author Michal Ociepka <M.Ociepka@netsync.pl>
  @version 0.1
*/
int modifyGoods (GString *string_no, xdfConnModule *conn_mod, int code_verify);

void clean (GtkWidget *widget);

void removeGoods (GtkWidget *widget, xdfConnModule *conn_mod);

void updateGoods (GtkWidget *widget, xdfConnModule *conn_mod);

void addGoods (GtkWidget *widget, xdfConnModule *conn_mod);

void findGoods (GtkWidget *widget, xdfConnModule *conn_mod);

void showGoodsClist (GtkWidget *widget, xdfConnModule *conn_mod);

void showServicesClist (GtkWidget *widget, xdfConnModule *conn_mod);

void updateFromClist (char *id, xdfConnModule *conn_mod);

int modifyStore (int kind_of_operation, xdfConnModule *conn_mod);

void addStore (GtkWidget *widget, xdfConnModule *conn_mod);

void remStore (GtkWidget *widget, xdfConnModule *conn_mod);

#endif /* __MODULE_GOODS_H__ */
