#include "moduleInvoices.h"
#include <iconv.h>

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  gtk_object_set_data_full (GTK_OBJECT (component), name, \
    gtk_widget_ref (widget), (GtkDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  gtk_object_set_data (GTK_OBJECT (component), name, widget)

GtkWidget *window;
GtkWidget *clist2, *clist3, *clist4;
GtkWidget *entry8; /* number NIP - search */
GtkWidget *entry9; /* Name - search */
GtkWidget *radiobutton1; /* radio ID */
GtkWidget *radiobutton2; /* radio Name */
GtkWidget *entry10; /* dodaj / usun artykul */
GtkWidget *entry_sum; /* suma zakupu */
GtkWidget *entry_nr_invoice;
GtkWidget *entry_date_print;
GtkWidget *entry_date_sell;
GtkWidget *entry_place;
GtkWidget *entry_order;
GtkWidget *entry_days_of_pay;
GtkWidget *entry_nr_wz;
GtkWidget *combo_pay;
gint timeout_clients,
     timeout_goods;
gchar option[256];

void selectionGoodsClist  ( GtkWidget *clist,
			    gint      row,
			    gint      column,
			    GdkEventButton *event,
			    xdfConnModule *conn_mod)
{
  gchar *text;
  
  gtk_clist_get_text (GTK_CLIST (clist), row, 0, &text);  
 
  conn_mod->id_goods = atoi (text); 
  conn_mod->row_buy = row;
}

void selectionClientsClist  ( GtkWidget *clist,
			    gint      row,
			    gint      column,
			    GdkEventButton *event,
			    xdfConnModule *conn_mod)
{
  conn_mod->clients_row = row;
}
void searchGoods (GtkWidget *widget, xdfConnModule *conn_mod)
{
  if ( GTK_IS_CLIST (clist3)) {

    char *text;
    int rows;
    int kind_of_search;
    struct xdfDialogMsgStruct msg_struct;
    gboolean search;

    updateGoodsClist (conn_mod);

    msg_struct.title = g_string_new ("Raport poszukiwan nabywcy");
    msg_struct.msg = g_string_new ("Nie ma takiego towaru / uslugi!!");

    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton1)) == TRUE)
      kind_of_search = 0;
    else 
      kind_of_search = 1;
  
    rows = (GTK_CLIST (clist3))->rows;
    search = FALSE;
    msg_struct.type = GTK_MESSAGE_WARNING;

    rows--;
    while (rows >= 0) {
      gtk_clist_get_text (GTK_CLIST (clist3), rows, kind_of_search, &text);
      if (strncmp (ENTRY_GET_TEXT (entry9), text, strlen ( ENTRY_GET_TEXT (entry9))) == 0) {
	gtk_clist_select_row (GTK_CLIST (clist3), rows, 1);
        gtk_clist_get_text (GTK_CLIST (clist3), rows, 1, &text);
	g_string_printf (msg_struct.msg, "Znalazlem nastepujacy towar / usluge: \n\n %s \n\n\t\t XdeFactor-ng", text); 
	search = TRUE;
	msg_struct.type = GTK_MESSAGE_INFO;
      }
      rows--;
    }
    xdfDialogMsg (&msg_struct);
    g_string_free (msg_struct.title, TRUE);
    g_string_free (msg_struct.msg, TRUE);
  }
}
void searchClientsNip (GtkWidget *widget, xdfConnModule *conn_mod)
{
  if ( GTK_IS_CLIST (clist2)) {

    char *text;
    int rows;
    struct xdfDialogMsgStruct msg_struct;

    updateClientsClist (conn_mod);

    msg_struct.title = g_string_new ("Raport poszukiwan nabywcy");
    msg_struct.msg = g_string_new ("Nie ma takiego nabywcy !!");
    msg_struct.type = GTK_MESSAGE_WARNING;

    rows = (GTK_CLIST (clist2))->rows;

    rows--;

    while (rows >= 0) {
      gtk_clist_get_text (GTK_CLIST (clist2), rows, 0, &text);
      if (strcmp (ENTRY_GET_TEXT (entry8), text) == 0) {
	gtk_clist_select_row (GTK_CLIST (clist2), rows, 1);
      gtk_clist_get_text (GTK_CLIST (clist2), rows, 1, &text);
	g_string_printf (msg_struct.msg, "Znalazlem nastepujacego nabywce: \n\n %s \n\n\t\t XdeFactor-ng", text); 
	msg_struct.type = GTK_MESSAGE_INFO;
      }
      rows--;
    }
    xdfDialogMsg (&msg_struct);
    g_string_free (msg_struct.title, TRUE);
    g_string_free (msg_struct.msg, TRUE);
  }
}
void updateClientsClist (xdfConnModule *conn_mod)
{
  if ( GTK_IS_CLIST (clist2)) {

    PGresult *res;
    gint i;
    gchar *result[2][2];

    res = PQexec (conn_mod->conn, "SELECT nip, name FROM clients WHERE is_active='TRUE' ORDER BY name;");
  
    gtk_clist_clear (GTK_CLIST (clist2));
    for (i=0; i < PQntuples (res); i++) {
      result[1][0] = PQgetvalue (res, i, 0);
      result[1][1] = PQgetvalue (res, i, 1);
      gtk_clist_append (GTK_CLIST (clist2), result[1]);
    }
  }
}
void updateGoodsClist (xdfConnModule *conn_mod)
{
  if ( GTK_IS_CLIST (clist3)) {

  PGresult *res;
  gint i;
  gchar *result[2][6];

  
  res = PQexec (conn_mod->conn, "SELECT goods_data.no,
					goods.name,
					units.name,
					goods_data.sell_price,
					goods_data.tax_vat,
					goods_data.store_state
				FROM
					goods_data, goods, units 
				WHERE
					goods.id=goods_data.goods_id
				and	goods.units_id=units.id
				and	goods.is_active='TRUE';");

  gtk_clist_clear ((GtkCList *) clist3);

  for (i=0; i < PQntuples (res); i++) {
    result[1][0] = PQgetvalue (res, i, 0);
    result[1][1] = PQgetvalue (res, i, 1);
    result[1][2] = PQgetvalue (res, i, 2);
    result[1][3] = PQgetvalue (res, i, 3);
    result[1][4] = PQgetvalue (res, i, 4);
    result[1][5] = PQgetvalue (res, i, 5);
    gtk_clist_append ((GtkCList *) clist3, result[1]);
  }
  }
}
void moduleInvoices (xdfConnModule *conn_mod)
{
struct xdfDialogMsgStruct msg_struct;

if (conn_mod->connect == 0) {
  GtkWidget *fixed1;
  GtkWidget *table1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *label5;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *combo1;
  GList *combo1_items = NULL;
  GtkWidget *label8;
  GtkWidget *fixed3;
  GtkWidget *fixed4;
  GtkWidget *frame1;
  GtkWidget *fixed2;
  GtkWidget *scrolledwindow1;
  GtkWidget *label12;
  GtkWidget *label13;
  GtkWidget *label15;
  GtkWidget *button1;
  GtkWidget *label9;
  GtkWidget *frame3;
  GtkWidget *fixed6;
  GtkWidget *scrolledwindow3;
  GtkWidget *label25;
  GtkWidget *label26;
  GtkWidget *label27;
  GtkWidget *label28;
  GtkWidget *label29;
  GtkWidget *label30;
  GtkWidget *label31;
  GtkWidget *label17;
  GtkWidget *frame2;
  GtkWidget *fixed5;
  GtkWidget *label24;
  GSList *radiobutton1_group = NULL;
  GtkWidget *hbuttonbox1;
  GtkWidget *button3;
  GtkWidget *button4;
  GtkWidget *scrolledwindow2;
  GtkWidget *label18;
  GtkWidget *label19;
  GtkWidget *label20;
  GtkWidget *label21;
  GtkWidget *label22;
  GtkWidget *label23;
  GtkWidget *label16;
  GtkWidget *button2;
  GtkWidget *label32;
	GtkWidget *label_[1];
  iconv_t desc=0;
  size_t length_conv;
  size_t length_=127;
  char *buffer, *safe_buff;
  char *char_conv;
	  

  GString *string_time = g_string_new ("time");
  time_t curtime;
  struct tm *loctime;
  char_conv = option;

  conn_mod->id_goods = -1;
  conn_mod->clients_row = -1;

  safe_buff = buffer = (char *)malloc(128);
  desc = iconv_open ("UTF-8", "ISO-8859-2");

  curtime = time (NULL);

  loctime = localtime (&curtime);

  conn_mod->invoice_number = g_string_new ("");
  conn_mod->invoice_prefix = g_string_new ("");
  /*
    Przez to uzyskujemy date postaci europejskiej 
  */
  strftime (option, 128, "%d.%m.%Y", loctime);
  g_string_printf (string_time, option);
  
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window), "Fakturowanie -- XdeFactor-ng");
  gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);

  fixed1 = gtk_fixed_new ();
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (window), fixed1);

  table1 = gtk_table_new (3, 6, TRUE);
  gtk_widget_show (table1);
  gtk_fixed_put (GTK_FIXED (fixed1), table1, 10, 10);
  gtk_widget_set_usize (table1, 760, 83);

  label1 = gtk_label_new ("Numer faktury :");
  gtk_widget_show (label1);
  gtk_table_attach (GTK_TABLE (table1), label1, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);

  label2 = gtk_label_new ("Data wystawienia :");
  gtk_widget_show (label2);
  gtk_table_attach (GTK_TABLE (table1), label2, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label2), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);

  label3 = gtk_label_new ("Data sprzedazy :");
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table1), label3, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label3), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label3), 0, 0.5);

  entry_nr_invoice = gtk_entry_new ();
  gtk_widget_show (entry_nr_invoice);
  gtk_table_attach (GTK_TABLE (table1), entry_nr_invoice, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (entry_nr_invoice, 0, 25);

  entry_date_print = gtk_entry_new ();
  gtk_widget_show (entry_date_print);
  gtk_table_attach (GTK_TABLE (table1), entry_date_print, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (entry_date_print, 0, 25);
  ENTRY_SET_TEXT (entry_date_print, string_time->str);

  entry_date_sell = gtk_entry_new ();
  gtk_widget_show (entry_date_sell);
  gtk_table_attach (GTK_TABLE (table1), entry_date_sell, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (entry_date_sell, 0, 25);
  ENTRY_SET_TEXT (entry_date_sell, string_time->str);

  label4 = gtk_label_new (" Miejsce wystaw. :     ");
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table1), label4, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label4), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label4), 0, 0.5);

  label5 = gtk_label_new (" Numer zamowienia :     ");
  gtk_widget_show (label5);
  gtk_table_attach (GTK_TABLE (table1), label5, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label5), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label5), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label5), 0, 0.5);

  label6 = gtk_label_new (" Numer dok. WZ :     ");
  gtk_widget_show (label6);
  gtk_table_attach (GTK_TABLE (table1), label6, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label6), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label6), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label6), 0, 0.5);

  entry_place = gtk_entry_new ();
  gtk_widget_show (entry_place);
  gtk_table_attach (GTK_TABLE (table1), entry_place, 3, 4, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (entry_place, -2, 25);

  search (SPRZEDAWCA, "miejsce_wystaw", option);
  iconv (desc, &char_conv, &length_conv, &buffer, &length_);
  ENTRY_SET_TEXT (entry_place, safe_buff);
  iconv_close (desc);
  free (safe_buff);

  entry_order = gtk_entry_new ();
  gtk_widget_show (entry_order);
  gtk_table_attach (GTK_TABLE (table1), entry_order, 3, 4, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (entry_order, -2, 25);

  entry_nr_wz = gtk_entry_new ();
  gtk_widget_show (entry_nr_wz);
  gtk_table_attach (GTK_TABLE (table1), entry_nr_wz, 3, 4, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (entry_nr_wz, -2, 25);

  label7 = gtk_label_new (" Sposob zaplaty :     ");
  gtk_widget_show (label7);
  gtk_table_attach (GTK_TABLE (table1), label7, 4, 5, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label7), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label7), 0, 0.5);

  combo1 = gtk_combo_new ();
  gtk_object_set_data (GTK_OBJECT (GTK_COMBO (combo1)->popwin),
                       "GladeParentKey", combo1);
  gtk_widget_show (combo1);
  gtk_table_attach (GTK_TABLE (table1), combo1, 5, 6, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  combo1_items = g_list_append (combo1_items, (gpointer) "Gotówka");
  combo1_items = g_list_append (combo1_items, (gpointer) "Przelew");
  gtk_combo_set_popdown_strings (GTK_COMBO (combo1), combo1_items);
  g_list_free (combo1_items);

  combo_pay = GTK_COMBO (combo1)->entry;
  gtk_widget_show (combo_pay);
  gtk_widget_set_usize (combo_pay, 49, -2);

  label8 = gtk_label_new (" Przelew (ilosc dni) :     ");
  gtk_widget_show (label8);
  gtk_table_attach (GTK_TABLE (table1), label8, 4, 5, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label8), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label8), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label8), 0, 0.5);

  entry_days_of_pay = gtk_entry_new ();
  gtk_widget_show (entry_days_of_pay);
  gtk_table_attach (GTK_TABLE (table1), entry_days_of_pay, 5, 6, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (entry_days_of_pay, 60, 25);

  fixed3 = gtk_fixed_new ();
  gtk_widget_show (fixed3);
  gtk_table_attach (GTK_TABLE (table1), fixed3, 4, 5, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  fixed4 = gtk_fixed_new ();
  gtk_widget_show (fixed4);
  gtk_table_attach (GTK_TABLE (table1), fixed4, 5, 6, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_show (frame1);
  gtk_fixed_put (GTK_FIXED (fixed1), frame1, 8, 95);
  gtk_widget_set_usize (frame1, 768, 127);

  fixed2 = gtk_fixed_new ();
  gtk_widget_show (fixed2);
  gtk_container_add (GTK_CONTAINER (frame1), fixed2);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_fixed_put (GTK_FIXED (fixed2), scrolledwindow1, 8, 8);
  gtk_widget_set_usize (scrolledwindow1, 542, 101);

  clist2 = gtk_clist_new (2);
  gtk_widget_show (clist2);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist2);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 1, 242);
  gtk_clist_column_titles_show (GTK_CLIST (clist2));

  label12 = gtk_label_new ("Numer NIP ");
  gtk_widget_show (label12);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 0, label12);
  gtk_label_set_justify (GTK_LABEL (label12), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label12), TRUE);

  label13 = gtk_label_new ("Nazwa firmy");
  gtk_widget_show (label13);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 1, label13);
  gtk_label_set_justify (GTK_LABEL (label13), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label13), TRUE);

  label15 = gtk_label_new ("Znajdz wg. numeru NIP :");
  gtk_widget_show (label15);
  gtk_fixed_put (GTK_FIXED (fixed2), label15, 560, 8);
  gtk_widget_set_usize (label15, 180, 25);
  gtk_label_set_justify (GTK_LABEL (label15), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label15), TRUE);

  entry8 = gtk_entry_new ();
  gtk_widget_show (entry8);
  gtk_fixed_put (GTK_FIXED (fixed2), entry8, 568, 40);
  gtk_widget_set_usize (entry8, 158, 20);
  g_signal_connect (G_OBJECT (entry8), "activate", G_CALLBACK (searchClientsNip), conn_mod);

  button1 = gtk_button_new_from_stock ("gtk-find");
  gtk_widget_show (button1);
  gtk_fixed_put (GTK_FIXED (fixed2), button1, 568, 72);
  gtk_widget_set_usize (button1, 164, 32);

  label9 = gtk_label_new ("Lista firm (odbiorcow)");
  gtk_widget_show (label9);
  gtk_frame_set_label_widget (GTK_FRAME (frame1), label9);
  gtk_label_set_justify (GTK_LABEL (label9), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label9), TRUE);

  frame3 = gtk_frame_new (NULL);
  gtk_widget_show (frame3);
  gtk_fixed_put (GTK_FIXED (fixed1), frame3, 8, 384);
  gtk_widget_set_usize (frame3, 768, 136);

  fixed6 = gtk_fixed_new ();
  gtk_widget_show (fixed6);
  gtk_container_add (GTK_CONTAINER (frame3), fixed6);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow3);
  gtk_fixed_put (GTK_FIXED (fixed6), scrolledwindow3, 8, 8);
  gtk_widget_set_usize (scrolledwindow3, 542, 108);

  clist4 = gtk_clist_new (7);
  gtk_widget_show (clist4);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), clist4);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 0, 26);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 1, 142);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 2, 62);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 3, 41);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 4, 78);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 5, 85);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 6, 15);
  gtk_clist_column_titles_show (GTK_CLIST (clist4));

  label25 = gtk_label_new ("ID");
  gtk_widget_show (label25);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 0, label25);
  gtk_label_set_justify (GTK_LABEL (label25), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label25), TRUE);

  label26 = gtk_label_new ("Nazwa towaru / uslugi");
  gtk_widget_show (label26);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 1, label26);
  gtk_label_set_justify (GTK_LABEL (label26), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label26), TRUE);

  label27 = gtk_label_new ("Cena netto");
  gtk_widget_show (label27);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 2, label27);
  gtk_label_set_justify (GTK_LABEL (label27), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label27), TRUE);

  label28 = gtk_label_new ("Ilosc");
  gtk_widget_show (label28);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 3, label28);
  gtk_label_set_justify (GTK_LABEL (label28), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label28), TRUE);

  label29 = gtk_label_new ("Wartosc VAT");
  gtk_widget_show (label29);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 4, label29);
  gtk_label_set_justify (GTK_LABEL (label29), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label29), TRUE);

  label30 = gtk_label_new ("Wartosc brutto");
  gtk_widget_show (label30);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 5, label30);
  gtk_label_set_justify (GTK_LABEL (label30), GTK_JUSTIFY_LEFT);

  label32 = gtk_label_new ("Rabat");
  gtk_widget_show (label32);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 6, label32);
  gtk_label_set_justify (GTK_LABEL (label32), GTK_JUSTIFY_LEFT);

  label17 = gtk_label_new ("Szczegoly faktury ");
  gtk_widget_show (label17);
  gtk_frame_set_label_widget (GTK_FRAME (frame3), label17);
  gtk_label_set_justify (GTK_LABEL (label17), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label17), TRUE);

  frame2 = gtk_frame_new (NULL);
  gtk_widget_show (frame2);
  gtk_fixed_put (GTK_FIXED (fixed1), frame2, 8, 232);
  gtk_widget_set_usize (frame2, 768, 151);

  fixed5 = gtk_fixed_new ();
  gtk_widget_show (fixed5);
  gtk_container_add (GTK_CONTAINER (frame2), fixed5);

  label24 = gtk_label_new ("Znajdz wg :");
  gtk_widget_show (label24);
  gtk_fixed_put (GTK_FIXED (fixed5), label24, 568, 8);
  gtk_widget_set_usize (label24, 82, 16);
  gtk_label_set_justify (GTK_LABEL (label24), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label24), TRUE);

  radiobutton1 = gtk_radio_button_new_with_mnemonic (NULL, "ID");
  gtk_widget_show (radiobutton1);
  gtk_fixed_put (GTK_FIXED (fixed5), radiobutton1, 568, 24);
  gtk_widget_set_usize (radiobutton1, 83, 21);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton1), radiobutton1_group);
  radiobutton1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton1));

  entry9 = gtk_entry_new ();
  gtk_widget_show (entry9);
  gtk_fixed_put (GTK_FIXED (fixed5), entry9, 568, 48);
  gtk_widget_set_usize (entry9, 165, 20);
  g_signal_connect (G_OBJECT (entry9), "activate", G_CALLBACK (searchGoods), conn_mod);

  radiobutton2 = gtk_radio_button_new_with_mnemonic (NULL, "Nazwa");
  gtk_widget_show (radiobutton2);
  gtk_fixed_put (GTK_FIXED (fixed5), radiobutton2, 664, 24);
  gtk_widget_set_usize (radiobutton2, 83, 21);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton2), radiobutton1_group);
  radiobutton1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_fixed_put (GTK_FIXED (fixed5), hbuttonbox1, 560, 72);
  gtk_widget_set_usize (hbuttonbox1, 181, 39);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox1), 0);

  button3 = gtk_button_new_from_stock ("gtk-add");
  gtk_widget_show (button3);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button3);
  GTK_WIDGET_SET_FLAGS (button3, GTK_CAN_DEFAULT);

  button4 = gtk_button_new_from_stock ("gtk-remove");
  gtk_widget_show (button4);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button4);
  GTK_WIDGET_SET_FLAGS (button4, GTK_CAN_DEFAULT);

  label_[0] = gtk_label_new ("Ilosc :");
  gtk_widget_show (label_[0]);
  gtk_fixed_put (GTK_FIXED (fixed5), label_[0], 580, 112);
  gtk_widget_set_usize (label_[0], 32, 16);

  entry10 = gtk_entry_new ();
  gtk_widget_show (entry10);
  gtk_fixed_put (GTK_FIXED (fixed5), entry10, 640, 112);
  gtk_widget_set_usize (entry10, 94, 20);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow2);
  gtk_fixed_put (GTK_FIXED (fixed5), scrolledwindow2, 8, 8);
  gtk_widget_set_usize (scrolledwindow2, 542, 124);

  clist3 = gtk_clist_new (6);
  gtk_widget_show (clist3);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), clist3);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 0, 30);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 1, 165);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 2, 77);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 3, 82);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 4, 49);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 5, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist3));
  g_signal_connect (G_OBJECT (clist3), "select_row", G_CALLBACK (selectionGoodsClist), conn_mod);

  label18 = gtk_label_new ("ID");
  gtk_widget_show (label18);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 0, label18);
  gtk_label_set_justify (GTK_LABEL (label18), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label18), TRUE);

  label19 = gtk_label_new ("Nazwa towaru/uslugi");
  gtk_widget_show (label19);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 1, label19);
  gtk_label_set_justify (GTK_LABEL (label19), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label19), TRUE);

  label20 = gtk_label_new ("Jm");
  gtk_widget_show (label20);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 2, label20);
  gtk_label_set_justify (GTK_LABEL (label20), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label20), TRUE);

  label21 = gtk_label_new ("Cena netto");
  gtk_widget_show (label21);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 3, label21);
  gtk_label_set_justify (GTK_LABEL (label21), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label21), TRUE);

  label22 = gtk_label_new ("VAT");
  gtk_widget_show (label22);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 4, label22);
  gtk_label_set_justify (GTK_LABEL (label22), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label22), TRUE);

  label23 = gtk_label_new ("Ilosc w mag.");
  gtk_widget_show (label23);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 5, label23);
  gtk_label_set_justify (GTK_LABEL (label23), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label23), TRUE);

  label16 = gtk_label_new ("Lista towarow / uslug");
  gtk_widget_show (label16);
  gtk_frame_set_label_widget (GTK_FRAME (frame2), label16);
  gtk_label_set_justify (GTK_LABEL (label16), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label16), TRUE);

  label31 = gtk_label_new ("Suma:");
  gtk_widget_show (label31);
  gtk_fixed_put (GTK_FIXED (fixed1), label31, 570, 400);
  gtk_widget_set_usize (label31, 82, 16);
  gtk_label_set_justify (GTK_LABEL (label31), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label31), TRUE);
  
  entry_sum = gtk_entry_new();
  ENTRY_SET_TEXT (entry_sum, "0");
  gtk_entry_set_editable (GTK_ENTRY (entry_sum), FALSE);
  gtk_widget_show (entry_sum);
  gtk_fixed_put (GTK_FIXED (fixed1), entry_sum, 610, 400);
  gtk_widget_set_usize (entry_sum, 94, 23);

  button2 = gtk_button_new_from_stock ("gtk-print");
  gtk_widget_show (button2);
  gtk_fixed_put (GTK_FIXED (fixed1), button2, 604, 472);
  gtk_widget_set_usize (button2, 106, 32);


  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (window, window, "window");
  GLADE_HOOKUP_OBJECT (window, fixed1, "fixed1");
  GLADE_HOOKUP_OBJECT (window, table1, "table1");
  GLADE_HOOKUP_OBJECT (window, label1, "label1");
  GLADE_HOOKUP_OBJECT (window, label2, "label2");
  GLADE_HOOKUP_OBJECT (window, label3, "label3");
  GLADE_HOOKUP_OBJECT (window, entry_nr_invoice, "entry_nr_invoice");
  GLADE_HOOKUP_OBJECT (window, entry_date_print, "entry_date_print");
  GLADE_HOOKUP_OBJECT (window, entry_date_sell, "entry_date_sell");
  GLADE_HOOKUP_OBJECT (window, label4, "label4");
  GLADE_HOOKUP_OBJECT (window, label5, "label5");
  GLADE_HOOKUP_OBJECT (window, label6, "label6");
  GLADE_HOOKUP_OBJECT (window, entry_place, "entry_place");
  GLADE_HOOKUP_OBJECT (window, entry_order, "entry_order");
  GLADE_HOOKUP_OBJECT (window, entry_nr_wz, "entry_nr_wz");
  GLADE_HOOKUP_OBJECT (window, label7, "label7");
  GLADE_HOOKUP_OBJECT (window, combo1, "combo1");
  GLADE_HOOKUP_OBJECT (window, combo_pay, "combo_pay");
  GLADE_HOOKUP_OBJECT (window, label8, "label8");
  GLADE_HOOKUP_OBJECT (window, entry_days_of_pay, "entry_days_of_pay");
  GLADE_HOOKUP_OBJECT (window, fixed3, "fixed3");
  GLADE_HOOKUP_OBJECT (window, fixed4, "fixed4");
  GLADE_HOOKUP_OBJECT (window, frame1, "frame1");
  GLADE_HOOKUP_OBJECT (window, fixed2, "fixed2");
  GLADE_HOOKUP_OBJECT (window, scrolledwindow1, "scrolledwindow1");
  GLADE_HOOKUP_OBJECT (window, clist2, "clist2");
  GLADE_HOOKUP_OBJECT (window, label12, "label12");
  GLADE_HOOKUP_OBJECT (window, label13, "label13");
  GLADE_HOOKUP_OBJECT (window, label15, "label15");
  GLADE_HOOKUP_OBJECT (window, entry8, "entry8");
  GLADE_HOOKUP_OBJECT (window, button1, "button1");
  GLADE_HOOKUP_OBJECT (window, label9, "label9");
  GLADE_HOOKUP_OBJECT (window, frame3, "frame3");
  GLADE_HOOKUP_OBJECT (window, fixed6, "fixed6");
  GLADE_HOOKUP_OBJECT (window, scrolledwindow3, "scrolledwindow3");
  GLADE_HOOKUP_OBJECT (window, clist4, "clist4");
  GLADE_HOOKUP_OBJECT (window, label25, "label25");
  GLADE_HOOKUP_OBJECT (window, label26, "label26");
  GLADE_HOOKUP_OBJECT (window, label27, "label27");
  GLADE_HOOKUP_OBJECT (window, label28, "label28");
  GLADE_HOOKUP_OBJECT (window, label29, "label29");
  GLADE_HOOKUP_OBJECT (window, label30, "label30");
  GLADE_HOOKUP_OBJECT (window, label17, "label17");
  GLADE_HOOKUP_OBJECT (window, frame2, "frame2");
  GLADE_HOOKUP_OBJECT (window, fixed5, "fixed5");
  GLADE_HOOKUP_OBJECT (window, label24, "label24");
  GLADE_HOOKUP_OBJECT (window, radiobutton1, "radiobutton1");
  GLADE_HOOKUP_OBJECT (window, entry9, "entry9");
  GLADE_HOOKUP_OBJECT (window, radiobutton2, "radiobutton2");
  GLADE_HOOKUP_OBJECT (window, hbuttonbox1, "hbuttonbox1");
  GLADE_HOOKUP_OBJECT (window, button3, "button3");
  GLADE_HOOKUP_OBJECT (window, button4, "button4");
  GLADE_HOOKUP_OBJECT (window, entry10, "entry10");
  GLADE_HOOKUP_OBJECT (window, scrolledwindow2, "scrolledwindow2");
  GLADE_HOOKUP_OBJECT (window, clist3, "clist3");
  GLADE_HOOKUP_OBJECT (window, label18, "label18");
  GLADE_HOOKUP_OBJECT (window, label19, "label19");
  GLADE_HOOKUP_OBJECT (window, label20, "label20");
  GLADE_HOOKUP_OBJECT (window, label21, "label21");
  GLADE_HOOKUP_OBJECT (window, label22, "label22");
  GLADE_HOOKUP_OBJECT (window, label23, "label23");
  GLADE_HOOKUP_OBJECT (window, label16, "label16");
  GLADE_HOOKUP_OBJECT (window, button2, "button2");


  gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
  gtk_widget_show (window);
 

  /* standardowo przy wlaczeniu modulu uaktualniam wszystkie listy */
  updateClientsClist (conn_mod); 
  updateGoodsClist (conn_mod); 


  timeoutAdd (conn_mod);

  /* sygnaly */
  gtk_signal_connect (GTK_OBJECT (button1), "clicked", GTK_SIGNAL_FUNC (searchClientsNip), conn_mod);
  gtk_signal_connect (GTK_OBJECT (button3), "clicked", GTK_SIGNAL_FUNC (messageDiscount), conn_mod);
  gtk_signal_connect (GTK_OBJECT (button4), "clicked", GTK_SIGNAL_FUNC (remGoods), conn_mod);
  gtk_signal_connect (GTK_OBJECT (button2), "clicked", GTK_SIGNAL_FUNC (messagePrint), conn_mod);
  gtk_signal_connect (GTK_OBJECT (button2), "clicked", GTK_SIGNAL_FUNC (timeoutRemove), NULL);

  g_signal_connect (G_OBJECT (entry10), "activate", G_CALLBACK (messageDiscount), conn_mod);
  g_signal_connect (G_OBJECT (clist4), "select_row", G_CALLBACK (selectionGoodsClist), conn_mod);
  g_signal_connect (G_OBJECT (clist2), "select_row", G_CALLBACK (selectionClientsClist), conn_mod);

  g_signal_connect (G_OBJECT (window), "destroy",
		   G_CALLBACK (timeoutRemove),
		   NULL);

  g_signal_connect (G_OBJECT (window), "destroy",
		   G_CALLBACK (freeInvoiceStruct),
		   conn_mod);


  g_string_free (string_time, TRUE);
} else {
  msg_struct.msg = g_string_new ("Najpierw musisz sie zalogowac!! \n\n\t XdeFactor-ng");
  msg_struct.type = GTK_MESSAGE_WARNING;
  xdfDialogMsg (&msg_struct);

  g_string_free (msg_struct.msg, TRUE);
}
}
void timeoutRemove (GtkWidget *widget) 
{
  gtk_timeout_remove (timeout_goods);
  gtk_timeout_remove (timeout_clients);
}
void timeoutAdd (xdfConnModule *conn_mod)
{
  /* odswiezam liste nabywcow */
  search (XDEFACTOR_NG, "invoices_clients_clist", option);
  timeout_clients = gtk_timeout_add (atoi (option), (GtkFunction) updateClientsClist, (gpointer) conn_mod);

  /* odswiezam liste towarow */
  search (XDEFACTOR_NG, "invoices_goods_clist", option);
  timeout_goods = gtk_timeout_add (atoi (option), (GtkFunction) updateGoodsClist, (gpointer) conn_mod);
}
void freeInvoiceStruct (GtkWidget *widget, xdfConnModule *conn_mod)
{
  g_string_free (conn_mod->invoice_number, TRUE);
  g_string_free (conn_mod->invoice_prefix, TRUE);
}














