#include <gtk/gtk.h>
#include <postgresql/libpq-fe.h>
#include <stdlib.h>
#include <stdio.h>

#ifndef __XDEF_H__
#define __XDEF_H__

/** 
  Struktura zawierajace postawowe i wystarczajace informacje o stanie uzytkownika i polaczenia z baza danych.
  @param  conn wskaznik do polaczenia z baza danych PostgreSQL
  @param  connect stan zalogowania uzytkownika. Wartosc '0' oznacza, ze uzytkownik zalogowal sie do bazy, wartosc '-1', ze nie zalogowal sie. Modul startuje dopiero, uzytkownik zalogowal sie.
  @param  userID ID uztkownika, ktory wlasnie zalogowal sie do bazy danych
  @param  ip numer IP lokalnej maszyny
  @param  id_goods ID towaru, ktorego dodajemy do listy zakupow
  @param  row_buy Numer wiersza z listy zakupow
  @param  clients_row Numer wiersza klienta z tejze listy
  @param  invoice_number Numer faktury, ktra chcemy wydrukowac
  @author Michal Ociepka <M.Ociepka@netsync.pl>
  @version 0.1
*/
typedef struct 
{
  PGconn *conn;
  int connect;
  int userID;
  GString *ip;
  int id_goods;
  int row_buy;
  int clients_row;
  GString *invoice_number;
  GString *invoice_prefix;
} xdfConnModule;


#endif /* __XDEF_H__ */
