#include "moduleLogout.h"

GtkWidget *window_main;

void logoutUser (GtkWidget *widget, struct xdfConnModule *conn_mod)
{
  GString *string;
  struct xdfDialogMsgStruct msg_struct;
 
  if (conn_mod->connect == 0){
    string = g_string_new ("start");
    PQexec(conn_mod->conn, "BEGIN;");
    g_string_printf (string, "UPDATE users SET is_logged_in='FALSE' WHERE interface='xdefactor-ng' and ip='%s';", conn_mod->ip->str);
    PQexec (conn_mod->conn, string->str);
    msg_struct.msg = g_string_new ("Wlasnie zostales wylogowany!!\n\n\t XdeFactor-ng");
    msg_struct.type = GTK_MESSAGE_INFO;
    PQexec (conn_mod->conn, "COMMIT;");
    conn_mod->connect=-1;
    g_string_free (string, TRUE);
  }else{
    msg_struct.msg = g_string_new ("Najpierw musisz sie zalogowac. \n\n\t XdeFactor-ng");
    msg_struct.type = GTK_MESSAGE_WARNING;
  }

  xdfDialogMsg(&msg_struct);
  g_string_free (msg_struct.msg, TRUE);

}

void moduleLogout(struct xdfConnModule *conn_mod)
{

  GtkWidget *fixed1;
  GtkWidget *button_yes;
  GtkWidget *button_no;
  GtkWidget *label1;

  window_main = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window_main), "window", window_main);
  gtk_window_set_title (GTK_WINDOW (window_main), "Wylogowanie XdeFactor-ng");
  gtk_window_set_position (GTK_WINDOW (window_main), GTK_WIN_POS_CENTER);
  gtk_window_resize (GTK_WINDOW (window_main), 300, 140);
  gtk_widget_show (window_main);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (window_main), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (window_main), fixed1);

  button_yes = gtk_button_new_from_stock (GTK_STOCK_OK);
  gtk_widget_ref (button_yes);
  gtk_object_set_data_full (GTK_OBJECT (window_main), "button_yes", button_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_yes);
  gtk_fixed_put (GTK_FIXED (fixed1), button_yes, 16, 84);
  gtk_widget_set_usize (button_yes, 120, 32);
  gtk_signal_connect(GTK_OBJECT (button_yes), "clicked", GTK_SIGNAL_FUNC (logoutUser), conn_mod);
  gtk_signal_connect(GTK_OBJECT (button_yes), "clicked", GTK_SIGNAL_FUNC (gtk_widget_hide), window_main);
  gtk_signal_connect_object (GTK_OBJECT (button_yes), "clicked", GTK_SIGNAL_FUNC (gtk_widget_hide), window_main);

  button_no = gtk_button_new_from_stock (GTK_STOCK_NO);
  gtk_widget_ref (button_no);
  gtk_object_set_data_full (GTK_OBJECT (window_main), "button_no", button_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_no);
  gtk_fixed_put (GTK_FIXED (fixed1), button_no, 168, 84);
  gtk_widget_set_usize (button_no, 120, 32);
  gtk_signal_connect_object (GTK_OBJECT (button_no), "clicked", GTK_SIGNAL_FUNC (gtk_widget_hide), window_main);

  label1 = gtk_label_new ("Czy na pewno chcesz sie wylogowac ?");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (window_main), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed1), label1, 24, 32);
  gtk_widget_set_uposition (label1, 24, 32);
  gtk_widget_set_usize (label1, 256, 32);

}
GtkWidget *xdfDialogMsg (struct xdfDialogMsgStruct *strDialog)
{
  GtkWidget *dialog;
  GtkWidget *window;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   
  dialog = gtk_message_dialog_new (GTK_WINDOW (window),
				   GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				   strDialog->type,
				   GTK_BUTTONS_OK,
				   strDialog->msg->str);
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
  gtk_widget_show (dialog);

  gtk_dialog_run (GTK_DIALOG (dialog));
  gtk_widget_destroy (dialog);
  gtk_widget_destroy (window_main);

  return dialog;  
}


