#include "moduleMeansOfTransport.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  gtk_object_set_data_full (GTK_OBJECT (component), name, \
    gtk_widget_ref (widget), (GtkDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  gtk_object_set_data (GTK_OBJECT (component), name, widget)

void selectionMeansClist ( GtkWidget	*clist,
			     gint	row,
			     gint	cloumn,
			     GdkEventButton *event, 
			     struct xdfConnModule *conn_mod)
{
  gchar *text;

  gtk_clist_get_text (GTK_CLIST (clist), row, 0, &text);
  
  updateFromClist (text, conn_mod);
    
}
void updateMeansClist ( gpointer data, struct xdfConnModule *conn_mod )
{
  PGresult *res;
  gint i;
  gchar *result[2][3];

  PQexec (conn_mod->conn, "BEGIN;");

  

  res = PQexec (conn_mod->conn, "SELECT id, name, memo FROM means_of_transport ORDER BY name;");
 
  gtk_clist_clear ((GtkCList *) data);
  for (i=0; i < PQntuples (res); i++) {
    result[1][0] = PQgetvalue (res, i, 0);
    result[1][1] = PQgetvalue (res, i, 1);
    result[1][2] = PQgetvalue (res, i, 2);
    gtk_clist_append ((GtkCList *) data, result[1]);
  }

  PQexec (conn_mod->conn, "COMMIT;");
}
void showMeansClist (GtkWidget *widget, struct xdfConnModule *conn_mod)
{
  GtkWidget *window;
  GtkWidget *scrolledwindow1;
  GtkWidget *clist1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window), "Lista srodkow transportu");


  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_container_add (GTK_CONTAINER (window), scrolledwindow1);

  clist1 = gtk_clist_new (3);
  gtk_widget_show (clist1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist1);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 0, 37);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 1, 130);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 2, 77);
  gtk_clist_column_titles_show (GTK_CLIST (clist1));
  gtk_clist_set_shadow_type (GTK_CLIST (clist1), GTK_SHADOW_ETCHED_IN);

  label1 = gtk_label_new ("ID");
  gtk_widget_show (label1);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 0, label1);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);

  label2 = gtk_label_new ("NAZWA SRODKA TRANS.");
  gtk_widget_show (label2);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 1, label2);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);

  label3 = gtk_label_new ("OPIS SRODKA TRANS.");
  gtk_widget_show (label3);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 2, label3);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (window, window, "window");
  GLADE_HOOKUP_OBJECT (window, scrolledwindow1, "scrolledwindow1");
  GLADE_HOOKUP_OBJECT (window, clist1, "clist1");
  GLADE_HOOKUP_OBJECT (window, label1, "label1");
  GLADE_HOOKUP_OBJECT (window, label2, "label2");
  GLADE_HOOKUP_OBJECT (window, label3, "label3");

  updateMeansClist (clist1, conn_mod);
  g_signal_connect (G_OBJECT (clist1), "select_row", G_CALLBACK (selectionMeansClist), conn_mod);

  gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
  gtk_window_resize (GTK_WINDOW (window), 450, 150);
  gtk_widget_show (GTK_WIDGET (window));

}
