#include <gtk/gtk.h>
#include <postgresql/libpq-fe.h>
#include <stdlib.h>
#include <stdio.h>

#ifndef __XDEF_H__
#define __XDEF_H__

/** 
  Struktura zawierajace postawowe i wystarczajace informacje o stanie uzytkownika i polaczenia z baza danych.
  @param  conn wskaznik do polaczenia z baza danych PostgreSQL
  @param  connect stan zalogowania uzytkownika. Wartosc '0' oznacza, ze uzytkownik zalogowal sie do bazy, wartosc '-1', ze nie zalogowal sie. Modul startuje dopiero, uzytkownik zalogowal sie.
  @param  userID ID uztkownika, ktory wlasnie zalogowal sie do bazy danych
  @param  ip numer IP lokalnej maszyny
  @author Michal Ociepka <M.Ociepka@netsync.pl>
  @version 0.1
*/
struct xdfConnModule
{
  PGconn *conn;
  int connect;
  int userID;
  GString *ip;
};

#endif /* __XDEF_H__ */
